/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 2266 2011-11-22 09:40:42Z ertl-honda $
 */

/*
 *  åװ¸⥸塼 ֥AT91SKYEYEѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"
#include "target_asm.inc"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥
 */
        ATEXT
        AALIGN(2)
        AGLOBAL(hardware_init_hook)
ALABEL(hardware_init_hook)
        bx  lr

/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(irq_handler)
ALABEL(irq_handler)
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_IRQ_BIT) 
    stmfd sp!, {r0-r3, ip, lr, pc} /* pcϥߡ */

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_IRQ AOR CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */
    mov   lr, sp          /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */

    ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r3, [r2]
    add   r0, r3, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr   r0, =_kernel_istkpt
    ldr   sp, [r0]

ALABEL(irq_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    ldr   r1, =AIC_IVR
    ldr   r3, [r1]

    /*
     *  װȽ
     */
    ldr   r1, =AIC_ISR
    ldr   r3, [r1]

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   r0, =inh_ipm_tbl      /* ͥ٤ */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
    ldr   r0, =ipm              /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r2, [r0]              
    stmfd sp!,{r2}         
    str   r1, [r0]              /* (ǥ)ͥ٥ޥ򥻥å */

    /*
     * (ǥ)ͥ٥ޥ
     * 
     * դߤγͥ٤ꤵ줿׵ػߥե饰
     * ơ֥ͤ(ǥ)Ƴߤγ׵ػߥե饰ξ֤
     * ݻѿͤȤORIRCγ׵ػߥե饰˥åȤ롥
     */
    rsb   r1, r1,  #0           /* ǥåȤʤ褦ȿž */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    mvn   lr, #0                
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */    
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     *  ߥϥɥεưϤ
     */
    ldr   r0, =inh_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */    

    /*
     *  EOIΤ¸
     */
    mov   r1, #1
    mov   r1, r1, lsl r3
    stmfd sp!, {r1} 

    stmfd sp!,{r3}       /* inhno ¸  */

    /* 
     * ߵ 
     */         
    msr   cpsr_cxsf, #(CPSR_SVC)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    bx    r0

    ldmfd sp!,{r0}       /* inhno   */    
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_IRQ_BIT)

    /*
     * ߥꥢ
     */
    ldmfd   sp!,{r0}
    ldr     r3, =AIC_EOI
    str     r0, [r3]

    b     target_ret_int


/*
 *
 * åȰ¸㳰
 *
 */
    ATEXT
    AGLOBAL(target_exc_handler)
ALABEL(target_exc_handler)
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     *  λΥ쥸Ƥϰʲ̤ꡥ
     *    r0 : lr()
     *    r1 : spsr
     *    r2 : 㳰ֹ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_FIQ_BIT AOR CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */    
    mov   lr, sp          /* λΥåΤ */

    ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r3, [r0]              
    stmfd sp!, {r3}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    ldr   r0, =excpt_nest_count
    ldr   r3, [r0]
    stmfd sp!, {r3}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     * ͥCPU㳰Ƚꤹ
     * 
     * ͥCPU㳰ϡͥ¹桤ߥå֡
     * CPUå֡ͥγߥϥɥ¹ȯ
     * CPU㳰Ǥ롥ARMξϡSPSRI/Fե饰Τ줫'1'ʤ顤
     * 롥
     */
    tst   r1, #(CPSR_FIQ_BIT AOR CPSR_IRQ_BIT) 
    bne   target_kernel_unc_exc_handler /* ͥCPU㳰ν */

    /*
     * ȯΥƥȤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1    

    /* 
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ롥
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

ALABEL(target_exc_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm       
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */

    /* 
     * ߵ
     * CPU㳰ϥɥ̥롼ǸƤӽФᡤñSVC⡼
     * ˤǤ褤
     */
    msr   cpsr_cxsf, #(CPSR_SVC)
          
#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0, r3
    mov   lr, pc
    bx    r1

    ldmfd sp!,{r0}       /* excno   */    
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */


/*
 *
 * åȰ¸㳰ߤνи
 *
 */
    AGLOBAL(target_ret_exc)
ALABEL(target_ret_exc)
    /*
     * ͥγߤػߤ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_IRQ_BIT)  

    AGLOBAL(target_ret_int)
ALABEL(target_ret_int)
    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]
    rsb   r1, r1,  #0           /* ǥåȤʤ褦ȿž */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    mvn   lr, #0                
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */    
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */            
    b     ret_int


/*
 *
 * ͥCPU㳰ν
 *
 */
ALABEL(target_kernel_unc_exc_handler)
    /*
     * ȯΥƥȤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_kernel_unc_exc_handler_1
    
    /* 
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ롥
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

ALABEL(target_kernel_unc_exc_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */
    
    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

   /*
    * ƥ֡ʥƥȤϽˤCPU㳰ȯξ֤
    */
    ldr   r0, [lr]             /* CPU㳰ȯCPSRμ */
    and   r0, r0, #(CPSR_IRQ_BIT AOR CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr_cxsf, r0

    /* 
     * CPU㳰ϥɥθƤӽФ
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0, r3
    mov   lr, pc
    bx    r1

    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */        
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * CPU㳰
     */
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr_cxsf, r1         /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */
